/******************************************************
 *  MP3 Player  PIC18F27Q43
 *  SDCardFSPI1@@VS1011FSPI2@@OLEDF\tgSPI
******************************************************/
#include "mcc_generated_files/mcc.h"
#include <string.h>
#include "OLED_swlib.h"
#include "VS1011.h"
/**** ϐ` *****/
#define SDCARD_MOUNT_NAME    "/mnt/mydrive"
#define SDCARD_DEV_NAME      "/dev/mmcblka1"
uint16_t size, i, j;
uint8_t RdBuf[512], lvl;               // ǂݏopobt@
char DispBuf[512];                     // ȏpobt@
// j[\bZ[Wf[^
const uint8_t Msg1[] = " **MP3 Player** ";
const uint8_t Msg2[] = "Reset/Restart  ";
const uint8_t Msg3[] = "S1 Start/Next  ";
const uint8_t Msg4[] = "S2 Volume Up   ";
const uint8_t Msg5[] = "S3 Volume Down ";
const uint8_t Msg6[] = "Push S1! Start! ";
// bZ[Wf[^@ Ȗ 
const uint8_t Title[] = {0xFA, 0x20, 0x93, 0x94, 0x20, 0xFA, 0};
//uint8_t Title[] = "Music Title";
const uint8_t Album[] = "Album Title";
const uint8_t NoTITL[] = "No Title";
const uint8_t NoALBM[] = "No Album Title";
const uint8_t EndMsg[] = "All Play End!";
const uint8_t RstMsg[] = "Next for Restart";
/** Xe[g` **/
typedef enum
{
    /* X^[gXe[g */
    APP_STATE_INIT=0,  
    APP_START,
    APP_WAIT,
    /* AṽXe[g */
    APP_MOUNT_DISK,
    APP_OPEN_ROOT,        
    APP_FILE_SEARCH,        
    APP_OPEN_FILE,
    APP_OPEN_LONGFILE,        
    APP_FILE_READ_FIRST,
    APP_FILE_READ_NEXT,
    APP_SW_PROCESS,
    APP_FILE_CLOSE,            
    APP_FIND_NEXT,
    APP_END_ALL,  
    APP_UNMOUNT,
    APP_END_MSG,        
    APP_ERROR       
} APP_STATES;
/* FAT֘Aϐ` */
APP_STATES state;
FRESULT result;
FATFS drive;
FIL file;
FILINFO info;
FFDIR dj;
UINT NoRead;
/** ֐vg **/
void Title_Display(void);
void SW_Process(void);

/*****  C֐ ******************/
void main(void)
{
    SYSTEM_Initialize();
    // foCX
    OLED_Init();   
    SPI2_Open(SPI2_DEFAULT);
    VS1011_Init();   
    SetBassBoost(5, 15);       // ቹ
//    VS1011_SineTest();        // geXg
    state = APP_START;
    /********* C[v ***************/
    while (1)
    {
        /** FATXe[g֐ **/
        switch (state )
        {
            // j[ʕ\
            case APP_START:
                OLED_Clear(BLACK);
                // Jnj[\
                OLED_Str(0, 0, Msg1, BLACK, RED);
                OLED_Str(1, 1, Msg2, YELLOW, BLACK);
                OLED_Str(1, 2, Msg3, WHITE, BLACK);
                OLED_Str(1, 3, Msg4, WHITE, BLACK);
                OLED_Str(1, 4, Msg5, WHITE, BLACK); 
                OLED_Str(0, 6, Msg6, MAGENTA, BLACK);     
                state = APP_WAIT;                               // Next҂
                break;
            /** Jn҂***/
            case APP_WAIT:          
                if(Next_GetValue() == 0){                      // NextXCb`I
                    while(Next_GetValue() == 0);               // `b^O
                    __delay_ms(50);
                    state = APP_MOUNT_DISK;                     // }Eg
                }
                break;
            /** SDJ[h̃}Eg **/
            case APP_MOUNT_DISK:
                if (f_mount(&drive,"",1) != FR_OK)
                    state = APP_MOUNT_DISK;                     // sȂ}EgJԂ
                else{
                    state = APP_FILE_SEARCH;                    // Ȃt@CT[`
                }
                break; 
            // t@C    
            case APP_FILE_SEARCH: 
                result = f_findfirst(&dj, &info, "", "*.mp3");
                if((result == FR_OK) && (info.fname[0]))        // ł
                    state = APP_OPEN_FILE;                      // t@C̃I[v                    
                else
                    state = APP_END_ALL;                        // I
                break;    
            /* t@CI[vs */  
            case APP_OPEN_FILE:
                if (f_open(&file, info.fname,  FA_READ) == FR_OK)
                    state = APP_FILE_READ_FIRST;                // LȂǂݏo
                else
                    state = APP_ERROR;                          // G[
                break;                
            /** MP3wb_ǂݏo\ **/
            case APP_FILE_READ_FIRST:
                /*** o\ ****/
                Blue_SetHigh();
                f_read (&file, RdBuf, 512, &NoRead);           // 512oCgꊇǂݏo
                Title_Display();                                // Ȗ\s
                /** ȃf[^̍ŏ̓] ***/
                XDCS_SetLow();                                  // f[^[h
                for(i=0; i<size; i++){                          // Sf[^JԂ
                    SendData(RdBuf[i]);                         // VS1011֓]                
                }
                state = APP_FILE_READ_NEXT;                     // ̃R[h        
                break;
            // R[hĐ@ŋȂ̏I܂ŌJԂ
            case APP_FILE_READ_NEXT:
                // XCb`̏
                /** NextXCb``FbN **/
                if(Next_GetValue() == 0){                       // NextXCb`I
                    while(Next_GetValue() == 0);                // `b^O
                    __delay_ms(10);
                    state = APP_FILE_CLOSE;                     // N[Y
                    break;
                }                
               // ̃XCb`̏
                SW_Process();                                   // ̃XCb`            
                // ̃R[hǂݏo
                f_read (&file, RdBuf, 512, &NoRead);           // 512oCgꊇǂݏo
                if(NoRead != 0){                                // t@C̏IłȂ
                    /** ȃf[^̈ꊇ] ***/
                    XDCS_SetLow();                              // f[^[h
                    for(i=0; i<NoRead; i++){                    // Sf[^JԂ
                        SendData(RdBuf[i]);                     // VS1011֓]                
                    }            
                }
                else                                            // t@CȈꍇ
                    state = APP_FILE_CLOSE;                     // ݂̃t@CN[Y            
                break;
            /** t@CN[YĎ **/
            case APP_FILE_CLOSE:                                // t@CN[Y
                f_close(&file);
                Blue_SetLow();            
                PlayEnd();                                      // VS1011obt@NA
                state = APP_FIND_NEXT;                          // ̃t@C
                break;
            case APP_FIND_NEXT:
                result = f_findnext(&dj, &info);
                if((result == FR_OK) && (info.fname[0] != 0))   // 
                    state = APP_OPEN_FILE;                      // 
                else
                    state = APP_END_ALL;                        // 
                break;
            /** St@CIŊ ***/
            case APP_END_ALL:                                   // St@CI
                f_close(&file); 
                PlayEnd();                                      // obt@NA
                state = APP_UNMOUNT;                            // A}Eg
                break;
            /** A}Eg ***/
            case APP_UNMOUNT:
                if(f_unmount("") != FR_OK)                      // A}Egs
                    state = APP_UNMOUNT;
                else{
                    state = APP_END_MSG;                        // IbZ[W
                    Blue_SetLow();
                }
                break;
            case APP_END_MSG:                                   // IbZ[W\
                OLED_Clear(BLACK);
                OLED_Str(0, 2, EndMsg, GREEN,BLACK);
                OLED_Str(0, 4, RstMsg, GREEN, BLACK);
                state = APP_WAIT;                               // Jn҂
                break;                
            /** ANZXG[̏ꍇ **/
            case APP_ERROR:

                break;
            default:
                break;
        }        
    }
}
/*************************
 * XCb`s
 *************************/
void SW_Process(void)
{
    /** ʒ ***/
    if(Up_GetValue() == 0){             // ʃAbv
        if(lvl > 0)
            lvl--;
        SetVolume(lvl, lvl);            // AbvR}hM
    }                 
    else if(Down_GetValue() == 0){      // ʃ_E
        if(lvl < 0xFE)
            lvl++;
        SetVolume(lvl, lvl);            // _ER}hM                 
    }
}
/*******************************
 * ^Cg\
 ******************************/
void Title_Display(void){
    uint8_t x, y;
    uint16_t FindFlag;
    uint8_t  Namesize; 
    
    OLED_Clear(BLACK);
    /** o\ **/
    OLED_xStr(0, 0, Title, GREEN, BLACK); 
    //mp3wb_o
    memcpy(DispBuf, (char*)RdBuf, 512);        // 0.5kBRs[
    FindFlag = 0;
    for(i=0; i<512; i++){                      // TIT2^OT[`
        if((DispBuf[i] == 'T')&&(DispBuf[i+1]=='I')&&(DispBuf[i+2] == 'T')&&(DispBuf[i+3] == '2')){
            FindFlag = 1;                       // 狭
            break;
        }
    }
    if(FindFlag == 1){
        Namesize = DispBuf[i+7];                // ^Cg擾
        DispBuf[i+10+Namesize] = 0;             // ^Cg̍Ō0X00㏑
        /** Ȗ\ **/
        j = i+11; x = 0; y = 1;                 // ϐZbg
        while(DispBuf[j] != 0){                 // Ō܂ŌJԂ
            if((DispBuf[j] < 0x80)||(DispBuf[j] > 0xA0)){  // ASCIȈꍇ
                OLED_xChar(x, y, (uint8_t)DispBuf[j], WHITE, BLACK);
                j++;
            }
            else if(DispBuf[j] <= 0x98){        // ̏ꍇ
                KanjiCode(x, y,(uint8_t)DispBuf[j],(uint8_t)DispBuf[j+1],WHITE, BLACK);
                j += 2;
            }
            // \ʒuXV
            x++;                    //J
            if( x > 7){             //8
                x = 0;      
                y++;                // C
                if(y > 5)           // 5s
                    y = 1;
            }
        }
    }
    else{
        OLED_xStr(0, 1, NoTITL, WHITE, BLACK);   // f[^̏ꍇ
    }
}