/*****************************************
 * BME280Wi-Fi̘Ag
 * ESPWROOM-02
 * Curiosity Nano PIC18F57Q43
 *****************************************/
#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/weather.h"
#include <string.h>
// 萔Aϐ`
char data[128]={0}, Length[20]={0}, Msg[128];
char Flag; 
/** ֐vg **/
bool getResponse(char *word, uint16_t timeout);

/************************
 * ^C}0@Callback֐
 ************************/
void TMR0_Process(void){
    Flag = 1;
}
/***** C֐ **********/
void main(void)
{
    SYSTEM_Initialize();
    // ^C}0 Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    // ESP Initialize
    RST_SetLow();                   // ESP Reset
    EN_SetHigh();
    RST_SetHigh();                  // ESP Reset Off
    __delay_ms(1000);
    // 荞݋iUART)
    INTERRUPT_GlobalInterruptEnable();   
    /*** [hݒ@****/
    LED_SetLow();
    printf("AT+CWMODE=1\r\n");                      // Xe[V[h 
    if(getResponse("OK", 1)==false){}               // OK҂   

    /***** C[v *******************/
    while (1)
    {
        if(Flag == 1){           
            Flag = 0;
            /** ANZX|CgƐڑ *****/
            do{
                printf("AT+CWJAP=\"----SSID----\",\"--password--\"\r\n");
            }while(getResponse("GOT IP", 10)==false);       // GOT IPԂ܂ŌJԂ
            /** TCPT[oƐڑ **/
            do{
                printf("AT+CIPSTART=\"TCP\",\"192.168.11.5\",9000\r\n");
            }while(getResponse("CONNECT", 2)==false);       // CONNECTł܂ŌJԂ             
            // ZTf[^擾MbZ[W쐬
            Weather_readSensors();
            sprintf(Msg, "T=%02.1fC,P=%04.1fhPa,H=%02.1f%%RH\r\n", 
                    Weather_getTemperatureDegC(), Weather_getPressureKPa()*10, Weather_getHumidityRH());           
            // TCPŃT[oɑM
            sprintf(Length, "AT+CIPSEND=%d\r\n", strlen(Msg));
            printf(Length);                                 // M
            if(getResponse(">", 3)==false){}                // OK > ҂
            // ZTf[^M
            printf(Msg);
            if(getResponse("SEND OK", 3)==false){}          // SEND OK҂  
            // T[oڑ؂藣
            printf("AT+CIPCLOSE\r\n");
            if(getResponse("OK", 5)==false){}               // OK҂
            printf("AT+CWQAP\r\n");
            if(getResponse("OK", 5)==false){}               // OK҂            
        }
    }
}

/************************************************
 *  ESPR}h҂
 * @^C}PŃ^CAEgo
 *@ Timer1 31kHz/8=3875 -> 1sec @Max 16sec
 ************************************************/
bool getResponse(char *word, uint16_t timeout){
    char a, flag;
    uint16_t j;

    j = 0;    
    flag = 0;                                   // 񔭌tOZbg
    TMR1_WriteTimer(0xFFFF-timeout*3887);       // ^C}bZbg
    TMR1_StartTimer();                          // ^C}PX^[g
    PIR3bits.TMR1IF = 0;                        // ^C}tOZbg    
    /******/
    while(PIR3bits.TMR1IF == 0){                // ^CAbv܂ŌJԂ
        while(UART1_is_rx_ready() == true){     // Mf[^̏ꍇ
            a = (char)getch();               // Mf[^擾
            if(a == '\0') continue;             // 0x00͏Ȃ
            UART5_Write(a);                     // Debug Out
            data[j] = a;                        // Mobt@ɒǉ
            if(j<126)                           // 126ȏ͖
                j++;                            // ̃obt@
            data[j] = 0;                        // ĨtO
        }
        if((a == '\n')||(a == '>')){            // s܂́̏ꍇ
            if(strstr(data, word) != 0){        // 񌟍
                flag = 1;                       // 񔭌tOI
                TMR1_StopTimer();               // ^C}1~
                break;                          // I
            }
            j = 0;                              // obt@ŏɖ߂
        }
    }
    if(flag == 1)
        return true;                            // 񂪌ꍇ
    else
        return false;                           // ^CAbv̏ꍇ      
}
