/********************************************************
 *  2.8"[OtBbNLCD(320240hbgjpCu
 *     iILI9341Rg[p)
 *	lcd_Init();     // 
 *	lcd_Clear();	// Sʏ
 *	lcd_Pixel();	// 1hbg\
 *	lcd_Char();     // ANK\
 *	lcd_Str();      // ANK\
 *	lcd_Line();     // `
 *	lcd_Circle();	// ~`
 *********************************************************/
#include "mcc_generated_files/mcc.h"
#include "colorlcd28.h"
#include "font_level1_lib.h"
/**************************************
 *  LCDփR}h/f[^1oCgM
 *  Max 50MHz  SSsgp
 **************************************/
void lcd_data(uint8_t Ctrl, uint8_t data){
    CS_SetLow(); 
    if(Ctrl == 0)
        DC_SetLow();                     // Command
    else
        DC_SetHigh();                   // Data
    SPI2_ExchangeByte((uint8_t)data);   // Ms
    CS_SetHigh();
}
/****************************
* LCD֐  
*****************************/
void lcd_Init(void){  
    CS_SetHigh();
    DC_SetHigh();
    RST_SetLow();
    __delay_ms(10);             // 10ms
    RST_SetHigh();
    __delay_ms(150);            // 150ms 
    SPI2_Open(SPI2_DEFAULT);
    // Sequence
    lcd_data(0, 0xCB);
    lcd_data(1, 0x39);
    lcd_data(1, 0x2C);
    lcd_data(1, 0x00);    
    lcd_data(1, 0x34);     
    lcd_data(1, 0x02);
    
    lcd_data(0, 0xCF);
    lcd_data(1, 0x00);
    lcd_data(1, 0x81);          // C1
    lcd_data(1, 0x30);          // E0
    
    lcd_data(0, 0xE8);
    lcd_data(1, 0x85);          // 8A
    lcd_data(1, 0x00);          // 01
    lcd_data(1, 0x7A);          // 78

    lcd_data(0, 0xEA);
    lcd_data(1, 0x00);
    lcd_data(1, 0x00);
    
    lcd_data(0, 0xED);
    lcd_data(1, 0x64);          // 
    lcd_data(1, 0x03);
    lcd_data(1, 0x12); 
    lcd_data(1, 0x81); 
 
    lcd_data(0, 0xF7);
    lcd_data(1, 0x20);    
     
    lcd_data(0, 0xC0);          // Power Cont
    lcd_data(1, 0x21);          // VRH    21
    
    lcd_data(0, 0xC1);          // Power Cont
    lcd_data(1, 0x10);          // SAP. BT   10

    lcd_data(0, 0xC5);          // VCM Cont
    lcd_data(1, 0x3F);          // 2D
    lcd_data(1, 0x3C);          // 33
   
    lcd_data(0, 0xC7);          // VCM2 Cont
    lcd_data(1, 0xA7);          // C1
    
    lcd_data(0, 0x36);          // Memory  Access  MADCTL
#ifdef Vertical
    lcd_data(1, 0xA8);          // A868ŏ㉺]
#endif
#ifdef Horizontal
    lcd_data(1, 0x08);          // 08C8ŏ㉺]
#endif
    lcd_data(0, 0x3A);          // COLMOD Pixel Format 16bit
    lcd_data(1, 0x55);
    
    lcd_data(0, 0xB1);
    lcd_data(1, 0x00);
    lcd_data(1, 0x1B);          // 1D    
    
    lcd_data(0, 0xB6);          // Display Function
    lcd_data(1, 0x0A);
    lcd_data(1, 0x02);

    lcd_data(0, 0xF2);          // 3Gamma Function Disable
    lcd_data(1, 0x00);  
    
    lcd_data(0, 0x26);          // Gamma curve select
    lcd_data(1, 0x01);

    lcd_data(0, 0xE0);          // Set Gamma
    lcd_data(1, 0x0F);
    lcd_data(1, 0x3A);    
    lcd_data(1, 0x36);    
    lcd_data(1, 0x0B);    
    lcd_data(1, 0x0D);    
    lcd_data(1, 0x06);    
    lcd_data(1, 0x4C);    
    lcd_data(1, 0x91);    
    lcd_data(1, 0x31);    
    lcd_data(1, 0x08);    
    lcd_data(1, 0x10);    
    lcd_data(1, 0x04);
    lcd_data(1, 0x11);
    lcd_data(1, 0x0C);    
    lcd_data(1, 0x00);  
    
    lcd_data(0, 0xE1);          // Set Gamma
    lcd_data(1, 0x00);
    lcd_data(1, 0x06);
    lcd_data(1, 0x0A);
    lcd_data(1, 0x05);
    lcd_data(1, 0x12);
    lcd_data(1, 0x09);
    lcd_data(1, 0x2C);
    lcd_data(1, 0x92);
    lcd_data(1, 0x3F);
    lcd_data(1, 0x08);
    lcd_data(1, 0x0E);
    lcd_data(1, 0x0B);
    lcd_data(1, 0x2E);
    lcd_data(1, 0x33);
    lcd_data(1, 0x0F);  
    
    lcd_data(0, 0x11);          // Exit Sleep
    __delay_ms(150);            // 150ms
    lcd_data(0, 0x21);          // Inversion off
    lcd_data(0, 0x29);          // Display On

}
/***************************
* ʏ֐
* pFw肠
****************************/
void lcd_Clear(uint16_t Color){
    uint32_t l;
    // Sʔ͈͎w
    lcd_data(0, 0x2A);              // Y Display Area
    lcd_data(1, 0x00);              // Y Start
    lcd_data(1, 0x00);
#ifdef Vertical
    lcd_data(1, 0x01);              // Y End
    lcd_data(1, 0x3F);
#endif
#ifdef Horizontal
    lcd_data(1, 0x00);              // Y End
    lcd_data(1, 0xEF);  
#endif    
    lcd_data(0, 0x2B);              // X Display Area
    lcd_data(1, 0x00);              // X Start
    lcd_data(1, 0x00);
#ifdef Vertical
    lcd_data(1, 0x00);              // X End
    lcd_data(1, 0xEF);  
#endif
#ifdef Horizontal
    lcd_data(1, 0x01);              // X End
    lcd_data(1, 0x3F);
#endif
    // 16rbgJ[œhԂ
    lcd_data(0, 0x2C);
    for(l=0; l<76800; l++){
    lcd_data(1, (Color >> 8));
        lcd_data(1, (Color & 0xFF));
    }
}
/***********************************
*  PsNZ\֐
*  W(0,0)-(319,239)  
***********************************/
void lcd_Pixel(int16_t Xpos, int16_t Ypos, uint16_t Color){
    lcd_data(0, 0x2A);                      // Y Display Area
    lcd_data(1, (uint8_t)(Ypos>>8));        // Y Start
    lcd_data(1, (uint8_t)(Ypos&0xFF));
    lcd_data(1, (uint8_t)(Ypos>>8));        // Y End
    lcd_data(1, (uint8_t)(Ypos&0xFF));
    lcd_data(0, 0x2B);                      // X Display Area
    lcd_data(1, (uint8_t)(Xpos>>8));        // X Start
    lcd_data(1, (uint8_t)(Xpos&0xFF));
    lcd_data(1, (uint8_t)(Xpos>>8));        // X End
    lcd_data(1, (uint8_t)(Xpos&0xFF));    
    // 16rbgJ[ŏ
    lcd_data(0, 0x2C);
    lcd_data(1, (Color >> 8));
    lcd_data(1, (Color & 0xFF));
}
/***************************
*  `֐
 * (x0, y0)(x1, y1)̒
 * _͍
***************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void lcd_Line(int16_t x0, int16_t y0, int16_t x1, int16_t y1, uint16_t Color)
{
    int16_t steep, t, deltax, deltay, error, x, y, ystep;

    y0=ENDPAGE-y0;					// YW]
    y1=ENDPAGE-y1;
    /// ̑傫ق߂
    steep = (abs(y1 - y0) > abs(x1 - x0));
    /// A̓ւ
    if(steep){
        t = x0; x0 = y0; y0 = t;
        t = x1; x1 = y1; y1 = t;
    }
    if(x0 > x1) {
        t = x0; x0 = x1; x1 = t;
        t = y0; y0 = y1; y1 = t;
    }
    deltax =x1 - x0;               // XvZ	
    deltay = abs(y1 - y0);
    error = 0;
    y = y0;
    /// XŃXebv̐؂ւ
    if(y0 < y1) ystep = 1; else ystep = -1;
    /// _ŕ`
    for(x=x0; x<=x1; x++) {
        if(steep) lcd_Pixel(y,x,Color); else lcd_Pixel(x,y,Color);
        error += deltay;
        if((error << 1) >= deltax) {
            y += ystep;
            error -= deltax;
        }
    }
}
/*************************************
*  ~`֐
*  S_Ɣaw
*  (FussỹASYgp)
**************************************/
void lcd_Circle(int16_t x0, int16_t y0, int16_t r, uint16_t color)
{
    int16_t x = r;
    int16_t y = 0;
    int16_t F = -2 * r + 3;

    while(x >= y){
        lcd_Pixel(x0+x, y0+y, color);
        lcd_Pixel(x0-x, y0+y, color);		
        lcd_Pixel(x0+x, y0-y, color);
        lcd_Pixel(x0-x, y0-y, color);		
        lcd_Pixel(x0+y, y0+x, color);
        lcd_Pixel(x0-y, y0+x, color);		
        lcd_Pixel(x0+y, y0-x, color);
        lcd_Pixel(x0-y, y0-x, color);
        if(F >= 0){
            x--;
            F -= 4 * x;
        }
        y++;
        F += 4 * y + 2;
    }
}
/*****************************************
*  ANK\֐ 8x8hbg
*  320/8=40/s@240/8=30s
*  (0, 0) - (39, 29)͈̔
******************************************/
void lcd_sChar(int16_t colum, int16_t line, const uint8_t letter, uint16_t Color1, uint16_t Color2){
	int16_t j, i;
    uint8_t Mask;

    for(j=0; j<5; j++){                     // 5hbg
        Mask = 0x80;                        // ʃrbg\
        for(i=0; i<8; i++){                 // c1C\
            if((Font[letter-0x20][j] & Mask) != 0)
                lcd_Pixel(colum*8+j, (line+1)*8-i, Color1);
            else
                lcd_Pixel(colum*8+j, (line+1)*8-i, Color2); //wiF	
            Mask = Mask >> 1;
        }
    }
    for(j=5; j<8; j++){
        lcd_Pixel(colum*8+j, (line+1)*8-i, Color2); //wiF
    }
}
/******************************
*   ANK`֐
*   4030sŎw
******************************/
void lcd_sStr(int16_t colum, int16_t line, const uint8_t *s, uint16_t Color1, uint16_t Color2)
{
    while (*s != 0){
        lcd_sChar(colum++, line, *s++, Color1, Color2);
        if(colum >= sXChar){
            line++;
            colum = 0;
            if(line >= sYLine)
                line = 0;
        }
    }
}
/*****************************************
*  ASCII\֐ 12x12hbg
*  FAwiF@w肠
*  30~17s 
******************************************/
void lcd_Char(int16_t colum, int16_t line, uint8_t letter, uint16_t Color1, uint16_t Color2){
    int16_t i, j;
    uint8_t Mask;

    // ANK\ó@3oCg2C6JԂ
    for(j=0; j<6; j++){
        // 8hbgA̕\
        Mask = 0x80;
        for(i=0; i<8; i++){
            // PCڑO8hbg\
            if((ANKFont[letter][j*3] & Mask) != 0)
                lcd_Pixel(colum*12+i, line*14+j*2, Color1);
            else
                lcd_Pixel(colum*12+i, line*14+j*2, Color2); 	//wiF
            // 2Cڌ㔼8hbg\
            if((ANKFont[letter][j*3+2] & Mask) != 0)
                lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color1);
            else
                lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color2); 	//wiF
            Mask = Mask >> 1;
        }
        // 4hbg\
        Mask = 0x80;
        // 1Cڌ㔼4hbg\
        for(i=0; i<4; i++){
            if((ANKFont[letter][j*3+1] & Mask) != 0)
                lcd_Pixel(colum*12+i+8, line*14+j*2, Color1);
            else
                lcd_Pixel(colum*12+i+8, line*14+j*2, Color2);	 //wiF
            Mask = Mask >> 1;
        }
        // 2CڑO4hbg\
        for(i=4; i<8; i++){
            if((ANKFont[letter][j*3+1] & Mask) != 0)
                lcd_Pixel(colum*12+i-4, line*14+j*2+1, Color1);
            else
                lcd_Pixel(colum*12+i-4, line*14+j*2+1, Color2); 	//wiF
            Mask = Mask >> 1;
        }							
    }
 
}
/******************************
*  ASCII`֐
*  12x12hbgtHg
******************************/
void lcd_Str(int16_t colum, int16_t line, const uint8_t *s, uint16_t Color1, uint16_t Color2)
{
    while (*s != 0){
        lcd_Char(colum++, line, *s++, Color1, Color2);
        if(colum >= XChar){
            line++;
            colum = 0;
            if(line >= YLine)
                line = 0;
        }
    }
}
/*************************************
* \@R[hwŕ\
* @2oCgR[hŎw
*  ShiftJISR[h 
**************************************/
void KanjiCode(int16_t colum, int16_t line, int16_t upcode, int16_t lowcode, uint16_t Color1, uint16_t Color2)
{
	int16_t upper, lower, i, j, k;
    uint8_t Mask, font_data[18];
	// R[hzCfbNXvZ(0x9440OŔz؂ւ)
    if(upcode < 0x94)                       // 94O̊
        upper = (upcode -0x81)*188;         // xxFC-xx40+1-1(7F)
    else
        upper = (upcode - 0x94)*188;        // 0x94ȏ̊            
    if(lowcode < 0x7F)						// R[h7F̓XLbv
        lower = (lowcode - 0x40);
    else
        lower = (lowcode - 0x41);			// 7FR[h1
    for(k=0; k<18; k++){                    // 118oCgo
        if(upcode < 0x94)
            font_data[k] = KanjiFont12b[upper+lower][k];    //0x9440O
        else
            font_data[k] = KanjiFont12bb[upper+lower][k];   // 0x9440ȍ~
    }
    // \ó@3oCg2C6JԂ
    for(j=0; j<6; j++){
        // 8hbgA̕\
        Mask = 0x80;
        for(i=0; i<8; i++){
            // PCڑO8hbg\
            if((font_data[j*3] & Mask) != 0)
                lcd_Pixel(colum*12+i, line*14+j*2, Color1);
            else
                lcd_Pixel(colum*12+i, line*14+j*2, Color2); //wiF
            // 2Cڌ㔼8hbg\
            if((font_data[j*3+2] & Mask) != 0)
                lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color1);
            else
                lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color2); //wiF
            Mask = Mask >> 1;
        }
        // 4hbg\
        Mask = 0x80;
        // 1Cڌ㔼4hbg\
        for(i=0; i<4; i++){
            if((font_data[j*3+1] & Mask) != 0)
                lcd_Pixel(colum*12+i+8, line*14+j*2, Color1);
            else
                lcd_Pixel(colum*12+i+8, line*14+j*2, Color2); //wiF
            Mask = Mask >> 1;
        }
        // 2CڑO4hbg\
        for(i=4; i<8; i++){
            if((font_data[j*3+1] & Mask) != 0)
                lcd_Pixel(colum*12+i-4, line*14+j*2+1, Color1);
            else
                lcd_Pixel(colum*12+i-4, line*14+j*2+1, Color2); //wiF
            Mask = Mask >> 1;
        }
    }
}	
/*********************************************************
* \
*  
*********************************************************/
void Kanji_Str(int16_t colum, int16_t line, const uint8_t *Msg, uint16_t Color1, uint16_t Color2)
{
    int16_t k;
    
    k=0;
    while(Msg[k] != 0){
			KanjiCode(colum++, line, (int16_t)Msg[k], (int16_t)Msg[k+1], Color1, Color2);
            k += 2;
			if(colum >= XChar){
				line++;
				colum = 0;
				if(line >= YLine)
					line = 0;
			}
		}
}

