/*************************************************
 *  j^
 * @xACACO"ZxvOLEDɕ\
 * @5ƂAmbientɑMăOt쐬
 * @UART1(Wi-Fi) UART5  UART3(CO2)
 *   SPI2(OLED)  I2C1(BME280)@
 ************************************************/
#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/weather.h"
#include "OLED_lib.h"
#include <string.h>
// 萔Aϐ`
char Flag, i, Interval, ErMsg[20], Error, STFlag;
char CO2Cmd[] = {0xFF, 0x01, 0x86, 0, 0, 0, 0, 0x79};
char CO2Data[9], DMsg[10];
uint16_t CO2, CO2S;
char Title[] = {0x20, 0xFA, 0xF0, 0xF1, 0xF2, 0xF3, 0xFA, 0x20, 0};  // 
char data[256], Body[200]={0}, POSTMsg[256]={0}, CIP[32];
// POSTf[^
char header[] = "POST /api/v2/channels/--ID--/data HTTP/1.1\r\n";
char host[] = "Host: 54.65.206.59\r\n";
char Length[] = "Content-Length: xxx\r\n";
char Type[] = "Content-Type: application/json\r\n\r\n";
char Keys[] = "{\"writeKey\":\"--Write Key--\",";
char Temp[20], Humi[20], Pres[20], CO2D[20];
/** ֐vg **/
bool getResponse(char *word, uint16_t timeout);
uint16_t GetCO2(void);
/**************************************
 * ^C}0@3bԊu@Callback֐
 *************************************/
void TMR0_Process(void){
    Flag = 1;
}
/******** C֐ **********************/
void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();
    // ^C}0 Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    // ESP Initialize
    printf("AT+CWMODE=1\r\n");          // Xe[V[h 
    if(getResponse("OK", 1)==false){}    
    // OLED
    OLED_Init();
    OLED_Clear(BLACK);
    // o\@啶
    OLED_xStr(0, 0, Title, WHITE, BLACK);   
    Flag = 0; 
    STFlag = 1;
    Interval = 100;
    // 荞݋
    INTERRUPT_GlobalInterruptEnable(); 
   // WeatherZT_~[i1ړǂݔ΂j
    Weather_readSensors();
    Weather_getTemperatureDegC();
    Weather_getHumidityRH();
    Weather_getPressureKPa();
    /******* C[v ***************************/
    while (1)
    {
        if(Flag == 1){                                          // tOȈꍇ
            Green_Toggle();                                     // ڈ
            Flag = 0;                                           // tOZbg
            // WeatherZTf[^擾\@啶
            OLED_xStr(0, 0, Title, WHITE, BLACK);               // oĕ\ 
            Weather_readSensors();                              // ZTvs
            sprintf(DMsg, "%2.1f %1c ", Weather_getTemperatureDegC(), 0xF8);
            OLED_xStr(0, 1, DMsg, MAGENTA, BLACK);              // x\
            sprintf(DMsg, "%2.1f %%RH", Weather_getHumidityRH());
            OLED_xStr(0, 2, DMsg, GREEN, BLACK);                // x\            
            sprintf(DMsg, "%4.0f hPa", Weather_getPressureKPa()*10);
            OLED_xStr(0, 3, DMsg, CYAN, BLACK);                 // C\
            // CO2f[^擾
            CO2 = GetCO2();                                     // ǂݍ
            if(CO2 > 400){                                      // 퉞̏ꍇ
                sprintf(DMsg, "%4.0f ppm", (double)CO2);
                OLED_xStr(0, 4, DMsg, YELLOW, BLACK);           // CO2\
                CO2S = CO2;                                     // Ambientp
            }
            /****** 5@AmbientM ************/
            Interval--;
            if(Interval <= 0){                                  // 5̏ꍇ
                Red_SetHigh();                                  // ڈ
                Interval = 100;                                 // 5Đݒ
                Error = 0x80;                                   // G[tOZbg
                /****** POSTf[^쐬 **********/            
                // ZTf[^ϊ 4
                sprintf(Temp, "\"d1\":\"%2.1f\",", Weather_getTemperatureDegC());
                sprintf(Humi, "\"d2\":\"%2.1f\",", Weather_getHumidityRH());
                sprintf(Pres, "\"d3\":\"%4.1f\",", Weather_getPressureKPa()*10);
                sprintf(CO2D, "\"d4\":\"%4.0f\"}\r\n", (double)CO2S);
                // Body̍쐬
                Body[0] = '\0';
                strcat(Body, Keys);                             // WriteL[
                strcat(Body, Temp);                             // xf[^
                strcat(Body, Humi);                             // xf[^
                strcat(Body, Pres);                             // Cf[^  
                strcat(Body, CO2D);                             // CO2f[^                
                sprintf(Length, "Content-Length: %d\r\n", strlen(Body)); 
                // POSTf[^S̐
                sprintf(POSTMsg, "%s%s%s%s%s", header, host, Length, Type, Body);    
                
                /****** Ambient֑Ms ************/
                /***ANZX|CgƐڑ@****/
                do{
                    printf("AT+CWJAP=\"----ssid----\",\"--pass word--\"\r\n");                
                }while(getResponse("GOT IP", 10)==false);           // GOT IPԂ܂ŌJԂ              
                /** AmbientT[oƐڑ **/
                do{            
                    printf("AT+CIPSTART=\"TCP\",\"54.65.206.59\",80\r\n");                
                }while(getResponse("CONNECT", 5)==false);           // CONNECTɂȂ܂ŌJԂ            
                // TCPAmbientPOSTM           
                sprintf(CIP, "AT+CIPSEND=%d\r\n", strlen(POSTMsg));    // MZbg           
                printf(CIP);                                        // M
                if(getResponse(">", 3)==false){Error+=0x01;}        // OK >҂            
                printf(POSTMsg);                                        // POSTM 
                if(getResponse("SEND OK", 3)==false){Error+=0x02;}  // SEND OK҂
                // Ambient̉҂
                if(getResponse("200 OK", 3)==false){Error+=0x04;}   // HTTP/1.1 200 OK҂             
                if(getResponse("CLOSED", 3)==false){Error+=0x08;}   // CLOSED҂            
                __delay_ms(500);
                printf("AT+CWQAP\r\n");                            // APƂ̐ڑ
                if(getResponse("OK", 3)==false){Error+=0x10;}       // OK҂
                // fobOpG[JE^Mi0x80j
                sprintf(ErMsg, "\r\nError = %X\r\n\r\n", Error);  // ɕϊ
                i = 0;
                while(ErMsg[i] != 0){
                    UART5_Write(ErMsg[i++]);                        // 񑗐M
                } 
                Red_SetLow();
            }              
        }       
    }
}
/**********************************
 * CO2ZTf[^擾
 **********************************/
uint16_t GetCO2(void){
    uint16_t rcv;
    // CO2ZxA\
    for(i=0; i<8; i++)                      // 8oCgR}hM
        UART3_Write(CO2Cmd[i]);
    // Jn̉҂
    if(STFlag == 1){                        // Jn̏ꍇ
        if(UART3_is_rx_ready()){            // 
            STFlag = 0;                     // JntOZbg
        }
        return 0;                           // 0Ԃ
    }
    else{                                   // Jn̏ꍇ
        // f[^M
        while(UART3_Read() != 0xFF);        // 0xFFM҂
        for(i=0; i<7; i++)                  // 7oCgM
            CO2Data[i] = UART3_Read();
        rcv = CO2Data[1]*256 + CO2Data[2];
        if((rcv > 10000) || (rcv < 400))    // ُȏꍇ
            return 0;                       // 0Ԃ
        else
         return(rcv);                       // f[^Ԃ
    }
}
/************************************************
 *  ESPR}h҂
 * @^C}PŃ^CAEgo
 *@ Timer1 31kHz/8=3875 -> 1sec @Max 16sec
 ************************************************/
bool getResponse(char *word, uint16_t timeout){
    char a, flag;
    uint16_t j;
    
    j = 0;                                      // CfbNXZbg    
    flag = 0;                                   // 񔭌tOZbg
    TMR1_WriteTimer(0xFFFF-timeout*3874);       // ^C}bZbg
    TMR1_StartTimer();                          // ^C}PX^[g
    PIR3bits.TMR1IF = 0;                        // ^C}tOZbg    
    /** Ms ****/
    while(PIR3bits.TMR1IF == 0){                // ^CAbv܂ŌJԂ
        while(UART1_is_rx_ready() == true){     // Mf[^̏ꍇ
            a = (char)getch();                  // Mf[^擾
            if(a == '\0') continue;             // 0x00͏Ȃ
            UART5_Write(a);                     // Debug Out
            data[j] = a;                        // Mobt@ɒǉ
            if(j<254)                           // 256ȏ͖
                j++;                            // ̃obt@
            data[j] = 0;                        // ĨtO
        }
        // Mf[^
        if(( a == '\n')||(a == '>')){           // ̏Ȉꍇ܂́̏ꍇ
            if(strstr(data, word) != 0){        // 񌟍
                flag = 1;                       // 񔭌tOI
                TMR1_StopTimer();               // ^C}1~
                break;                          // I
            }
            j = 0;                              // obt@̍ŏɖ߂
        }
    }
    // ߂lZbg
    if(flag == 1)
        return true;                            // 񂪌ꍇ
    else
        return false;                           // ^CAbv̏ꍇ      
}
