/***************************************************
 *  Wave Generator
 *@@NCO+DMA+DACŔg`
 *    RTC+TNR3,4,6{CLCŎgJE^\
 *    1Hz40kHz̐gAOpgA`go
 *    ŏgݒ0.6HzXebv
 ***************************************************/
#include "mcc_generated_files/mcc.h"
#include <math.h>
#include <stdio.h>
#include "OLED_lib.h"
// f[^`
#define C 3.141592/180.0
#define Step 61.03515625        // 64MHz220 Max40kHz
//#define Step 15.258789        // 16MHz220@Max10kHz
uint16_t n, Count, Flag;
uint8_t SineWave[100], Msg[18];
char Message[11];
int8_t Select;
uint32_t Freq, SetData;
// bZ[Wf[^
const char Title[] = {0x81,0x7C,0x94,0x67,0x8C,0x60,0x90,0xB6,0x90,0xAC,0x8A,0xED,0x81,0x7C,0,0}; 
const char FrqTitl[] = {0x8E,0xFC,0x94,0x67,0x90,0x94,0,0};  // g
const char SinWave[] = {0x90,0xB3,0x8C,0xB7,0x94,0x67,0,0};  // g
const char TriWave[] = {0x8E,0x4F,0x8A,0x70,0x94,0x67,0,0};  // Opg
const char SawWave[] = {0x8B,0x98,0x8F,0xF3,0x94,0x67,0,0};  // g
const char PlsWave[] = {0x8B,0xE9,0x8C,0x60,0x94,0x67,0,0};  // `g
const char Kind[] =    {0x8F,0x6F,0x97,0xCD,0x94,0x67,0,0};  // o͔g
const char Display[] = {0x95,0x5C,0x8E,0xA6,0x81,0x40,0,0};  // \
const char Inhibit[] = {0x92,0xE2,0x8E,0x7E,0x92,0x86,0,0};  // ~
const char Enable[]  = {0x95,0x5C,0x8E,0xA6,0x92,0x86,0,0};  // \
const char Menu1[] = "S1 Freq Fast Up";
const char Menu2[] = "S2 Freq Fast Dwn";
const char Menu3[] = "S3 Freq Fine Up";
const char Menu4[] = "S4 Freq Fine Dwn";
const char Menu5[] = "S5 Display OnOff";
const char Menu6[] = "S6 Wave Select";
// ֐vg
void NCOSet(uint32_t set);
/*********************************
 * Timer3 Gate 荞Callback
 * gJE^
 *********************************/
void CLC2_Process(void){
    Count = TMR3_ReadTimer() ;                  // g擾  
    TMR3_WriteTimer(0);                         // ̃JEg0Jn        
    sprintf(Message, "F%5uHz", Count);          // \bZ[W쐬
    OLED_xStr(0, 1, Message, CYAN, BLACK);      // OLEDɕ\
    sprintf((char *)Msg, "\r\nFreq = %5u Hz", Count);  // UARTbZ[W쐬
    DMAnCON0bits.AIRQEN = 1;                    // DMA2~L
    DMA2_StartTransferWithTrigger();            // DMA2JniUARTM)
}

/******* C֐ ***************/
void main(void)
{
    SYSTEM_Initialize();                    // VXe
    DMA1_StopTransfer();                    // g`o͂~
    DMA2_StopTransfer();                    // DMA2~
    T6PR = 24;                              // TMR6@25JEgݒ
    // gf[^@100\@U}100@1.6Vpp
    for(n=0; n<100; n++){
        SineWave[n] = (uint8_t)(127.0 + 100*sin(C*(double)n*3.6));
    }    
    // lZbg
    Freq = 1000;                            // l1kHz
    NCOSet(Freq);  
    Select = 0;                             // g
    // j[\ Jn҂
    OLED_Init();
    OLED_Clear(BLACK);
    OLED_Str(0, 0, "-Wave Generator-", YELLOW, BLUE);
    OLED_Str(0, 1, Menu1, WHITE, BLACK);
    OLED_Str(0, 2, Menu2, WHITE, BLACK);
    OLED_Str(0, 3, Menu3, CYAN, BLACK);
    OLED_Str(0, 4, Menu4, CYAN, BLACK);
    OLED_Str(0, 5, Menu5, MAGENTA, BLACK);  
    OLED_Str(0, 6, Menu6, YELLOW, BLACK); 
    while(S5_GetValue() == 1);              // S5IŊJn
    DMA1_Initialize();                      // g`o͊Jn
    OLED_Clear(BLACK);
    OLED_Str(0, 0, "-Wave Generator-", YELLOW, BLUE);
    Kanji_Str(0, 2, Kind, WHITE, BLACK);
    Kanji_Str(4, 2, SinWave, RED, BLACK);
    Kanji_Str(0, 3, FrqTitl, WHITE, BLACK);
    Kanji_Str(4, 3, Enable, GREEN, BLACK);    
    __delay_ms(100);
    // 荞݋ CLC2 Fall@g\o͊Jn
    INTERRUPT_GlobalInterruptEnable();    
  
    /******* C[v ********************/
    while (1)
    {
        // g\̋֎~
        if(S5_GetValue() == 0){                     // S5I
            while(S5_GetValue() == 0);              // `b^
            __delay_ms(100);
             if(Flag == 1){                          // \̏ꍇ
                Flag = 0;
                Kanji_Str(4, 3, Inhibit, YELLOW, BLACK);  
                INTERRUPT_GlobalInterruptDisable(); // ~
            }
            else{                                   // ~̏ꍇ
                Flag = 1;
                Kanji_Str(4, 3, Enable, GREEN, BLACK);  
                INTERRUPT_GlobalInterruptEnable();  // \Jn
            }
        }          
        // g̃Abv@NCOݒ
        if(S1_GetValue() == 0){             // S1I
            __delay_ms(100);                // `b^ 
            if(S1_GetValue() == 0){         // I̊mF
                if(Freq > 10000){           // 10kHz荂ꍇ
                    Freq += 1000;           // 1kHzPʂŃAbv
                    if(Freq > 40000)        // 40kHzŐ
                        Freq = 40000;
                }
                else if(Freq > 1000)        // 1kHz荂ꍇ
                    Freq +=100;             // 100HzPʂŃAbv
                else                        // 1kHzȉ̏ꍇ
                    Freq += 10;             // 10HzPʂŃAbv
                NCOSet(Freq);               // NCOݒߐݒ
            }
        }
        // g_E@NCOݒ
        if(S2_GetValue() == 0){             // S2I
            __delay_ms(100);                // `b^
            if(S2_GetValue() == 0){         // I̊mF
                if(Freq < 1000){            // 1kHzȉ̏ꍇ
                    Freq -= 10;             // 10HzPʂŃ_E
                    if(Freq < 10)           // 10HzŐ
                        Freq = 10;
                }
                else if(Freq < 10000)       // 10kHzȉ̏ꍇ
                    Freq -= 100;            // 100HzPʂŃ_E
                else                        // 10kHzȏ̏ꍇ
                    Freq -= 1000;           // 1kHzPʂŃ_E
                NCOSet(Freq);               // NCOݒo
            }
        }
        // g@Abv
        if(S3_GetValue() == 0){             // S3I
            __delay_ms(100);                // `b^  
            if(S3_GetValue() == 0){         // I̊mF
                if(Freq < 1000)             // 1kHzȉ̏ꍇ
                    Freq += 1;              // 1HzPʂŃAbv
                else if(Freq < 40000)       // 40kHzȉ̏ꍇ
                    Freq += 10;             // 10HzPʂŃAbv
                NCOSet(Freq);               // NCOݒo
            }
        }
        // g@_E
        if(S4_GetValue() == 0){             // S4I
            __delay_ms(100);                // `b^ 
            if(S4_GetValue() == 0){         // I̊mF
                if(Freq > 1000)             // 1kHzȏ̏ꍇ
                    Freq -= 10;             // 10HzPʂŃ_E
                else if(Freq > 1)           // 1Hzȏ̏ꍇ
                    Freq -=1;               // 1HzPʂŃ_E
                NCOSet(Freq);               // NCOݒo
            }
        }
        // g`̕ύX
        if(S6_GetValue() == 0){             // S6I
            while(S6_GetValue() == 0);      // `b^
            __delay_ms(100);
            Select++;                       // tOAbv
            if(Select > 2)                  // 2̏ꍇ
                Select = 0;                 // 0ɖ߂
            switch(Select){                 // tOŕ
                case 0:
                    // gf[^@100\@U}100@3.0Vpp
                    for(n=0; n<100; n++){
                        SineWave[n] = (uint8_t)(127.0 + 100*sin(C*(double)n*3.6));
                    }
                    Kanji_Str(4, 2, SinWave, RED, BLACK);
                    break;
                case 1:
                    // Opg
                    for(n=0; n<50; n++){
                        SineWave[n] = (uint8_t)((n*4) + 28);
                    }
                    for(n=50; n<100; n++){
                        SineWave[n] = (uint8_t)(228.0 - (n-50)*4);
                    }
                    Kanji_Str(4, 2, TriWave, RED, BLACK);
                    break;
                case 2:
                    // g
                    for(n=0; n<100; n++){
                        SineWave[n]= (uint8_t)(n*2+28);
                    }
                    Kanji_Str(4, 2, SawWave, RED, BLACK);
                    break;
                default :
                    break;                    
            }
        }
    }
}
/**************************
 * NCO Setting
 *************************/
void NCOSet(uint32_t set){
    // NCOݒߐݒ
    NCO1CONbits.EN = 0;                     // NCO~
    SetData = (uint32_t)((set*100) / Step); // lvZ 
    NCO1INCL = SetData & 0x000000FF;        // ʃoCgݒ
    SetData >>= 8;
    NCO1INCH = SetData & 0x000000FF;        // ʃoCgݒ
    SetData >>= 8;
    NCO1INCU = SetData & 0x000000FF;        // ʃoCgݒ
    NCO1CONbits.EN = 1;                     // NCOĊJ
}